﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
//using System.Threading.Tasks; //.NET Framework 3.5 には含まれない
using System.Windows.Forms;

namespace MyClock
{
    public partial class Alarm : Form
    {
        public Alarm()
        {
            InitializeComponent();
        }

        // <Ver 1.10>アラーム時間の値(文字列)
        public static string m_alarmTime;

        // <Ver 1.11>アラーム解除フラグ
        public static bool m_alarmCanceled;

        // <Ver 1.13>前面表示時からアラーム画面のフラグ
        public static int m_Norm_alarm;

        // <Ver 1.13>アイコン表示時からアラームのフラグ
        public static int m_Icon_alarm;


        /// <summary>
        /// <Ver 1.10></Ver>
        /// アラーム設定フォーム描画
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Alarm_Load(object sender, EventArgs e)
        {
            // <Ver 1.10>アラーム時刻の読み込み
            if (m_alarmTime != null)
                setAlarm.Value = DateTime.Parse(m_alarmTime);
            else
                setAlarm.Value = DateTime.Now;

            // <Ver 1.11>アラーム解除フラグの読み込み
            if (m_alarmCanceled)
                checkbox_cancelAlarm.CheckState = CheckState.Checked;
            else
                checkbox_cancelAlarm.CheckState = CheckState.Unchecked;

            // <Ver 1.13>前面表示時のアラーム画面サイズフラグの読み込み
            switch (m_Norm_alarm)
            {
                case 1:
                    Norm_normDisp.Text = "▶前面";
                    m_Norm_alarm = 1;
                    break;
                case 2:
                    Norm_normDisp.Text = "▶最大化";
                    m_Norm_alarm = 2;
                    break;
                case 3:
                    Norm_normDisp.Text = "▶前面中央";
                    m_Norm_alarm = 3;
                    break;
            }

            // <Ver 1.13>アイコン表示時のアラーム画面サイズフラグの読み込み
            switch (m_Icon_alarm)
            {
                case 1:
                    Icon_maxDisp.Text = "▶前面";
                    m_Icon_alarm = 1;
                    break;
                case 2:
                    Icon_maxDisp.Text = "▶最大化";
                    m_Icon_alarm = 2;
                    break;
                case 3:
                    Icon_maxDisp.Text = "▶前面中央";
                    m_Icon_alarm = 3;
                    break;
            }

            // <Ver 1.11>アラーム設定フォームを時計の周りに重ならないように表示する
            // <Ver 1.11>Alarmフォームがあるディスプレイの高さと幅を取得
            int screenH = System.Windows.Forms.Screen.GetBounds(this).Height;
            int screenW = System.Windows.Forms.Screen.GetBounds(this).Width;

            // <Ver 1.11>MyClockフォームの左上の位置(left, top, width, height)を取得
            var left = this.Owner.Location.X;
            var top = this.Owner.Location.Y;
            var width = this.Owner.Width;
            var height = this.Owner.Height;

            // <Ver 1.11>Alarmフォームのデフォルトの位置(Dislayフォームの右隣)
            int X = left + width;
            int Y = top;
            // <Ver 1.11>Alarmフォームがスクリーンからはみ出す時、位置(X, Y)を更新
            if (X + this.Width > screenW)
                X = left - this.Width;
            if (Y + this.Height > screenH)
                Y = top + height - this.Height;

            // <Ver 1.11>親ウィンドウ (MyClock)の周りに移動させる
            this.Location = new Point(X, Y);
        }

        /// <summary>
        /// <Ver 1.10></Ver>
        /// [OK]ボタンクリックされた時のイベントハンドラ
        /// DateTimePickerの値を更新して終了する
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_OK_Click(object sender, EventArgs e)
        {
            m_alarmTime = setAlarm.Value.ToString("HH:mm:ss");
            // <Ver 1.10>[OK]クリックでもモーダルダイアログが OK を返さないので、
            // <Ver 1.10>強制的にOKを返す
            this.DialogResult = DialogResult.OK;
            Dispose();
        }

        /// <summary>
        /// <Ver 1.10></Ver>
        /// 現在時刻の取得ボタンのイベントハンドラ
        /// setAlarmを現在時刻で更新し、[OK]ボタンをアクティブにする
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_curTime_Click(object sender, EventArgs e)
        {
            setAlarm.Value = DateTime.Now;
            button_OK.Select();
        }

        /// <summary>
        /// <Ver 1.11></Ver>
        /// チェックボックスのイベントハンドラ
        /// アラーム解除チェックボックスの操作
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cancelAlarm_CheckedChanged(object sender, EventArgs e)
        {
            switch (checkbox_cancelAlarm.CheckState)
            {
                case CheckState.Checked:
                    m_alarmCanceled = true;
                    break;
                case CheckState.Unchecked:
                case CheckState.Indeterminate:
                    m_alarmCanceled = false;
                    break;
            }
        }

        /// <summary>
        /// <Ver 1.10></Ver>
        /// 前面 [▶前面]ボタンのイベントハンドラ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Norm_normDisp_Click(object sender, EventArgs e)
        {
            switch (m_Norm_alarm)
            {
                case 1:
                    Norm_normDisp.Text = "▶最大化";
                    m_Norm_alarm = 2;
                    break;
                case 2:
                    Norm_normDisp.Text = "▶前面中央";
                    m_Norm_alarm = 3;
                    break;
                case 3:
                    Norm_normDisp.Text = "▶前面";
                    m_Norm_alarm = 1;
                    break;
            }
            button_OK.Select();
        }

        /// <summary>
        /// <Ver 1.10></Ver>
        /// 最小化 [▶最大化]ボタンのイベントハンドラ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Icon_maxDisp_Click(object sender, EventArgs e)
        {
            switch (m_Icon_alarm)
            {
                case 1:
                    Icon_maxDisp.Text = "▶最大化";
                    m_Icon_alarm = 2;
                    break;
                case 2:
                    Icon_maxDisp.Text = "▶前面中央";
                    m_Icon_alarm = 3;
                    break;
                case 3:
                    Icon_maxDisp.Text = "▶前面";
                    m_Icon_alarm = 1;
                    break;
            }
            button_OK.Select();
        }

#if DEBUG
        /// <summary>
        /// <Ver 1.15.1></Ver>
        /// デバッグ用テストモード - いきなりアラーム発動
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void label_alarmState_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Yes;   // Yes を返す
            Dispose();
        }
#endif
    }
}
